from typing import Any

from .. import models as models
from .generic import AllMixin as AllMixin
from .generic import GetByIdMixin as GetByIdMixin
from .generic import Manager as Manager
from .generic import SyncMixin as SyncMixin

class ItemsManager(Manager, AllMixin, GetByIdMixin, SyncMixin):
    state_name: str
    object_type: str
    def add(self, content, **kwargs): ...
    def update(self, item_id, **kwargs) -> None: ...
    def delete(self, item_id) -> None: ...
    def move(self, item_id, **kwargs) -> None: ...
    def close(self, item_id) -> None: ...
    def complete(
        self,
        item_id,
        date_completed: Any | None = ...,
        force_history: Any | None = ...,
    ) -> None: ...
    def uncomplete(self, item_id) -> None: ...
    def archive(self, item_id) -> None: ...
    def unarchive(self, item_id) -> None: ...
    def update_date_complete(self, item_id, due: Any | None = ...) -> None: ...
    def reorder(self, items) -> None: ...
    def update_day_orders(self, ids_to_orders) -> None: ...
    def get_completed(self, project_id, **kwargs): ...
    def get(self, item_id): ...
