from typing import Any

class Model:
    temp_id: str
    data: Any
    api: Any
    def __init__(self, data, api) -> None: ...
    def __setitem__(self, key, value) -> None: ...
    def __getitem__(self, key): ...
    def __contains__(self, value): ...

class Collaborator(Model):
    def delete(self, project_id) -> None: ...

class CollaboratorState(Model): ...

class Filter(Model):
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...

class Item(Model):
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...
    def move(self, **kwargs) -> None: ...
    def reorder(self, child_order) -> None: ...
    def close(self) -> None: ...
    def complete(self, date_completed: Any | None = ...) -> None: ...
    def uncomplete(self) -> None: ...
    def archive(self) -> None: ...
    def unarchive(self) -> None: ...
    def update_date_complete(self, due: Any | None = ...) -> None: ...

class Label(Model):
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...

class LiveNotification(Model): ...

class GenericNote(Model):
    local_manager: Any
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...

class Note(GenericNote):
    local_manager: Any
    def __init__(self, data, api) -> None: ...

class ProjectNote(GenericNote):
    local_manager: Any
    def __init__(self, data, api) -> None: ...

class Project(Model):
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...
    def archive(self) -> None: ...
    def unarchive(self) -> None: ...
    def move(self, parent_id) -> None: ...
    def reorder(self, child_order) -> None: ...
    def share(self, email) -> None: ...
    def take_ownership(self) -> None: ...

class Reminder(Model):
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...

class Section(Model):
    def update(self, **kwargs) -> None: ...
    def delete(self) -> None: ...
    def move(self, project_id) -> None: ...
    def reorder(self, section_order) -> None: ...
    def archive(self, date_archived: Any | None = ...) -> None: ...
    def unarchive(self) -> None: ...
